 function out = CD_generation(res,n,t,gmma)
 % estimate classical CD
  rhohats   = corrcoef(res); % N x N           
  allrho    = triu(rhohats,1); 
  res_cov   = t^(-1)*(res'*res); % N x N
  res_var   = diag(res_cov); % N x 1              

  CDscaling   = sqrt(2*t/(n*(n-1)));
  CDtemp      = CDscaling*sum(allrho(:));
  CD     = CDtemp;
            
  % estimate ai
  sgm         = sqrt(mean(res.^2));
  eps         = res./sgm;
  phi         = mean(gmma./sgm,2);
  ai          = 1/sqrt(n)*(1-(gmma.*sgm)'*phi);
  % estimate moment of wt^2
  Ewt2        = sum(ai.^2);
        
  % new CD*
  CDs = (CD-sqrt(t/2)*(Ewt2-1))/Ewt2;
  % The method by Simon
  % Get weighted CD stat    
  % Function generating the random weights:
  weightgen = @(myen) (randi([0 1],1,myen)-0.5).*2;
  weights_p     = weightgen(n);
  weightsmat_p  = weights_p'*weights_p;
  allrho2_p     = triu(res_cov.*weightsmat_p,1);
  CDvar_p       = mean(res_var,1);
  CD_W_temp     = CDscaling*sum(allrho2_p(:))/CDvar_p;
  CDw      = CD_W_temp;             
                
  % Weighted CD with power enhancement 
  crit_base = 2*sqrt(log(n))*t^(-1/2);
  crit      = crit_base*sqrt(res_var*res_var');            
  ind_raw  = abs(res_cov)  > crit;
  corrXind = ind_raw.*abs(rhohats);
  powerplus_corr = sum(sum(tril(corrXind,-1)));                
  CDwn    = CD_W_temp(1,1) + powerplus_corr;

 
  out.CD = CD;
  out.CDs = CDs;
  out.CDw = CDw;
  out.CDwn = CDwn;
 end