% Calculate the residuals

%% with no season, no national, regional effects
 res01 = [];
for i=1:377
    datai = data1(i:377:i+377*(t-2),:);
    yi = datai(:,3);
    dres = yi-mean(yi);
    res01 = [res01;dres];%res1 arranged in the order of units
end

%% index
index = zeros(59943,1);
for it = 1:59943
    index(it) = 1*(data1(it,1)==1)+2*(data1(it,1)==2)...
        +3*(data1(it,1)==3|data1(it,1)==4)+4*(data1(it,1)==5)+5*(data1(it,1)==6|data1(it,1)==8)...
        +6*(data1(it,1)==7);
end
% label the regions
%%
%1(48), 2(59), 3(41), 4(37), 5(33), 6(120), 7(39)

res1 = [];
for i=1:377
    datai = data1(i:377:i+377*(t-2),:);
    yi = datai(:,3);
    xi = [ones(length(yi),1),(datai(:,2)==2),(datai(:,2)==3),(datai(:,2)==4)];
    beta = pinv(xi'*xi)*xi'*yi;
    dres = yi-xi*beta;
    res1 = [res1;dres];%res1 arranged in the order of units
end

% analysis without cross sectional average
%%  national effect
nationeffect = zeros((t-1),1);
for s=1:(t-1)
        nationeffect(s) = mean(data1((s-1)*377+1:377*s,3));
end

%% regional effect
rj = zeros(159,1,7);
for j=1:6%1:7,1:6
    dataj = data1(find(index==j),:);
    yj = dataj(:,3);
    nj = length(yj)/159;
    for s=1:159
        rj(s,1,j) = mean(yj((nj-1)*s+1:nj*s));
    end
end
%% with no season
res02 = [];

for i=1:377
    datai = data1(i:377:i+377*(t-2),:);
    indexi= index(i:377:i+377*(t-2),:);
    yi = datai(:,3);
    s  = mean(indexi);
    dt =[nationeffect,rj(:,:,s)];
    xi = [ones(length(yi),1),dt];
    beta = pinv(xi'*xi)*xi'*yi;
    dres = yi-xi*beta;
    res02 = [res02;dres];
end
%%
res2 = [];


for i=1:377
    datai = data1(i:377:i+377*(t-2),:);
    indexi= index(i:377:i+377*(t-2),:);
    yi = datai(:,3);
    s  = mean(indexi);
    dt =[nationeffect,rj(:,:,s)];
    xi = [ones(length(yi),1),(datai(:,2)==2),(datai(:,2)==3),(datai(:,2)==4),...
        dt];
    beta = pinv(xi'*xi)*xi'*yi;
    dres = yi-xi*beta;
    res2 = [res2;dres];
end