%% Test for error cross-sectional dependence of two factors model
%CD_sizepower_PMS: pure two factors model
%CD_sizepower_XPMS: panel data model with two factors

clear
clc

namefile   = 'PMF1';
rho1_mean  = zeros(80,0);
rho1_std   = zeros(80,0);
rho1_rej   = zeros(80,0);
rho2_mean  = zeros(80,0);
rho2_std   = zeros(80,0);
rho2_rej   = zeros(80,0);
rho3_mean  = zeros(80,0);
rho3_std   = zeros(80,0);
rho3_rej   = zeros(80,0);
rho4_mean  = zeros(80,0);
rho4_std   = zeros(80,0);
rho4_rej   = zeros(80,0);
rho5_mean  = zeros(80,0);
rho5_std   = zeros(80,0);
rho5_rej   = zeros(80,0);

R2_1  = zeros(20,0);
R2_2  = zeros(20,0);
R2_3  = zeros(20,0);
R2_4  = zeros(20,0);
R2_5  = zeros(20,0);


for loadingtype = 1 %[1 2 3]
    for errortype = 1 %[1 2]
        [mean1, std1, temprej1,PR2_1] = CD_sizepower_PMF(0,loadingtype,errortype);
        [mean2, std2, temprej2,PR2_2] = CD_sizepower_PMF(0.25,loadingtype,errortype);
        [mean3, std3, temprej3,PR2_3] = CD_sizepower_PMF(0.5,loadingtype,errortype); 
        [mean4, std4, temprej4,PR2_4] = CD_sizepower_PMF(0.75,loadingtype,errortype);
        [mean5, std5, temprej5,PR2_5] = CD_sizepower_PMF(0.95,loadingtype,errortype); 
        rho1_mean  = cat(2,rho1_mean,mean1);
        rho1_std   = cat(2,rho1_std,std1);
        rho1_rej   = cat(2,rho1_rej,temprej1);
        rho2_mean  = cat(2,rho2_mean,mean2);
        rho2_std   = cat(2,rho2_std,std2);
        rho2_rej   = cat(2,rho2_rej,temprej2);
        rho3_mean  = cat(2,rho3_mean,mean3);
        rho3_std   = cat(2,rho3_std,std3);
        rho3_rej   = cat(2,rho3_rej,temprej3);
        rho4_mean  = cat(2,rho4_mean,mean4);
        rho4_std   = cat(2,rho4_std,std4);
        rho4_rej   = cat(2,rho4_rej,temprej4);
        rho5_mean  = cat(2,rho5_mean,mean5);
        rho5_std   = cat(2,rho5_std,std5);
        rho5_rej   = cat(2,rho5_rej,temprej5);
        R2_1  = cat(2,R2_1,PR2_1);
        R2_2  = cat(2,R2_2,PR2_2);
        R2_3  = cat(2,R2_3,PR2_3);
        R2_4  = cat(2,R2_4,PR2_4);
        R2_5  = cat(2,R2_5,PR2_5);
    end
end

rho_mean = [rho1_mean,rho2_mean,rho3_mean,rho4_mean,rho5_mean];
rho_std  = [rho1_std,rho2_std,rho3_std,rho4_std,rho5_std];
rho_rej = [rho1_rej,rho2_rej,rho3_rej,rho4_rej,rho5_rej];
rho_R2  = [R2_1,R2_2,R2_3,R2_4,R2_5];
toEval = ['save ' namefile ';'];
% save namefile;
eval(toEval);
